/**
 * Copyright (C) 2020-2022 Dušan Vejnović <vaadin@dussan.org>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.dussan.vaadin.dvirtual.icons;

import com.vaadin.flow.component.icon.Icon;

public enum EntypoIcon
{

    ADD_TO_LIST( "add-to-list" ),
    CLASSIC_COMPUTER( "classic-computer" ),
    CONTROLLER_FAST_BACKWARD( "controller-fast-backward" ),
    CREATIVE_COMMONS_ATTRIBUTION( "creative-commons-attribution" ),
    CREATIVE_COMMONS_NODERIVS( "creative-commons-noderivs" ),
    CREATIVE_COMMONS_NONCOMMERCIAL_EU( "creative-commons-noncommercial-eu" ),
    CREATIVE_COMMONS_NONCOMMERCIAL_US( "creative-commons-noncommercial-us" ),
    CREATIVE_COMMONS_PUBLIC_DOMAIN( "creative-commons-public-domain" ),
    CREATIVE_COMMONS_REMIX( "creative-commons-remix" ),
    CREATIVE_COMMONS_SHARE( "creative-commons-share" ),
    CREATIVE_COMMONS_SHAREALIKE( "creative-commons-sharealike" ),
    CREATIVE_COMMONS( "creative-commons" ),
    DOCUMENT_LANDSCAPE( "document-landscape" ),
    REMOVE_USER( "remove-user" ),
    WARNING( "warning" ),
    ARROW_BOLD_DOWN( "arrow-bold-down" ),
    ARROW_BOLD_LEFT( "arrow-bold-left" ),
    ARROW_BOLD_RIGHT( "arrow-bold-right" ),
    ARROW_BOLD_UP( "arrow-bold-up" ),
    ARROW_DOWN( "arrow-down" ),
    ARROW_LEFT( "arrow-left" ),
    ARROW_LONG_DOWN( "arrow-long-down" ),
    ARROW_LONG_LEFT( "arrow-long-left" ),
    ARROW_LONG_RIGHT( "arrow-long-right" ),
    ARROW_LONG_UP( "arrow-long-up" ),
    ARROW_RIGHT( "arrow-right" ),
    ARROW_UP( "arrow-up" ),
    ARROW_WITH_CIRCLE_DOWN( "arrow-with-circle-down" ),
    ARROW_WITH_CIRCLE_LEFT( "arrow-with-circle-left" ),
    ARROW_WITH_CIRCLE_RIGHT( "arrow-with-circle-right" ),
    ARROW_WITH_CIRCLE_UP( "arrow-with-circle-up" ),
    BOOKMARK( "bookmark" ),
    BOOKMARKS( "bookmarks" ),
    CHEVRON_DOWN( "chevron-down" ),
    CHEVRON_LEFT( "chevron-left" ),
    CHEVRON_RIGHT( "chevron-right" ),
    CHEVRON_SMALL_DOWN( "chevron-small-down" ),
    CHEVRON_SMALL_LEFT( "chevron-small-left" ),
    CHEVRON_SMALL_RIGHT( "chevron-small-right" ),
    CHEVRON_SMALL_UP( "chevron-small-up" ),
    CHEVRON_THIN_DOWN( "chevron-thin-down" ),
    CHEVRON_THIN_LEFT( "chevron-thin-left" ),
    CHEVRON_THIN_RIGHT( "chevron-thin-right" ),
    CHEVRON_THIN_UP( "chevron-thin-up" ),
    CHEVRON_UP( "chevron-up" ),
    CHEVRON_WITH_CIRCLE_DOWN( "chevron-with-circle-down" ),
    CHEVRON_WITH_CIRCLE_LEFT( "chevron-with-circle-left" ),
    CHEVRON_WITH_CIRCLE_RIGHT( "chevron-with-circle-right" ),
    CHEVRON_WITH_CIRCLE_UP( "chevron-with-circle-up" ),
    CLOUD( "cloud" ),
    CONTROLLER_FAST_FORWARD( "controller-fast-forward" ),
    CONTROLLER_JUMP_TO_START( "controller-jump-to-start" ),
    CONTROLLER_NEXT( "controller-next" ),
    CONTROLLER_PAUS( "controller-paus" ),
    CONTROLLER_PLAY( "controller-play" ),
    CONTROLLER_RECORD( "controller-record" ),
    CONTROLLER_STOP( "controller-stop" ),
    CONTROLLER_VOLUME( "controller-volume" ),
    DOT_SINGLE( "dot-single" ),
    DOTS_THREE_HORIZONTAL( "dots-three-horizontal" ),
    DOTS_THREE_VERTICAL( "dots-three-vertical" ),
    DOTS_TWO_HORIZONTAL( "dots-two-horizontal" ),
    DOTS_TWO_VERTICAL( "dots-two-vertical" ),
    DOWNLOAD( "download" ),
    EMOJI_FLIRT( "emoji-flirt" ),
    FLOW_BRANCH( "flow-branch" ),
    FLOW_CASCADE( "flow-cascade" ),
    FLOW_LINE( "flow-line" ),
    FLOW_PARALLEL( "flow-parallel" ),
    FLOW_TREE( "flow-tree" ),
    INSTALL( "install" ),
    LAYERS( "layers" ),
    OPEN_BOOK( "open-book" ),
    RESIZE_100( "resize-100" ),
    RESIZE_FULL_SCREEN( "resize-full-screen" ),
    SAVE( "save" ),
    SELECT_ARROWS( "select-arrows" ),
    SOUND_MUTE( "sound-mute" ),
    SOUND( "sound" ),
    TRASH( "trash" ),
    TRIANGLE_DOWN( "triangle-down" ),
    TRIANGLE_LEFT( "triangle-left" ),
    TRIANGLE_RIGHT( "triangle-right" ),
    TRIANGLE_UP( "triangle-up" ),
    UNINSTALL( "uninstall" ),
    UPLOAD_TO_CLOUD( "upload-to-cloud" ),
    UPLOAD( "upload" ),
    ADD_USER( "add-user" ),
    ADDRESS( "address" ),
    ADJUST( "adjust" ),
    AIR( "air" ),
    AIRCRAFT_LANDING( "aircraft-landing" ),
    AIRCRAFT_TAKE_OFF( "aircraft-take-off" ),
    AIRCRAFT( "aircraft" ),
    ALIGN_BOTTOM( "align-bottom" ),
    ALIGN_HORIZONTAL_MIDDLE( "align-horizontal-middle" ),
    ALIGN_LEFT( "align-left" ),
    ALIGN_RIGHT( "align-right" ),
    ALIGN_TOP( "align-top" ),
    ALIGN_VERTICAL_MIDDLE( "align-vertical-middle" ),
    ARCHIVE( "archive" ),
    AREA_GRAPH( "area-graph" ),
    ATTACHMENT( "attachment" ),
    AWARENESS_RIBBON( "awareness-ribbon" ),
    BACK_IN_TIME( "back-in-time" ),
    BACK( "back" ),
    BAR_GRAPH( "bar-graph" ),
    BATTERY( "battery" ),
    BEAMED_NOTE( "beamed-note" ),
    BELL( "bell" ),
    BLACKBOARD( "blackboard" ),
    BLOCK( "block" ),
    BOOK( "book" ),
    BOWL( "bowl" ),
    BOX( "box" ),
    BRIEFCASE( "briefcase" ),
    BROWSER( "browser" ),
    BRUSH( "brush" ),
    BUCKET( "bucket" ),
    CAKE( "cake" ),
    CALCULATOR( "calculator" ),
    CALENDAR( "calendar" ),
    CAMERA( "camera" ),
    CCW( "ccw" ),
    CHAT( "chat" ),
    CHECK( "check" ),
    CIRCLE_WITH_CROSS( "circle-with-cross" ),
    CIRCLE_WITH_MINUS( "circle-with-minus" ),
    CIRCLE_WITH_PLUS( "circle-with-plus" ),
    CIRCLE( "circle" ),
    CIRCULAR_GRAPH( "circular-graph" ),
    CLAPPERBOARD( "clapperboard" ),
    CLIPBOARD( "clipboard" ),
    CLOCK( "clock" ),
    CODE( "code" ),
    COG( "cog" ),
    COLOURS( "colours" ),
    COMPASS( "compass" ),
    COPY( "copy" ),
    CREDIT_CARD( "credit-card" ),
    CREDIT( "credit" ),
    CROSS( "cross" ),
    CUP( "cup" ),
    CW( "cw" ),
    CYCLE( "cycle" ),
    DATABASE( "database" ),
    DIAL_PAD( "dial-pad" ),
    DIRECTION( "direction" ),
    DOCUMENT( "document" ),
    DOCUMENTS( "documents" ),
    DRINK( "drink" ),
    DRIVE( "drive" ),
    DROP( "drop" ),
    EDIT( "edit" ),
    EMAIL( "email" ),
    EMOJI_HAPPY( "emoji-happy" ),
    EMOJI_NEUTRAL( "emoji-neutral" ),
    EMOJI_SAD( "emoji-sad" ),
    ERASE( "erase" ),
    ERASER( "eraser" ),
    EXPORT( "export" ),
    EYE( "eye" ),
    FEATHER( "feather" ),
    FLAG( "flag" ),
    FLASH( "flash" ),
    FLASHLIGHT( "flashlight" ),
    FLAT_BRUSH( "flat-brush" ),
    FOLDER_IMAGES( "folder-images" ),
    FOLDER_MUSIC( "folder-music" ),
    FOLDER_VIDEO( "folder-video" ),
    FOLDER( "folder" ),
    FORWARD( "forward" ),
    FUNNEL( "funnel" ),
    GAME_CONTROLLER( "game-controller" ),
    GAUGE( "gauge" ),
    GLOBE( "globe" ),
    GRADUATION_CAP( "graduation-cap" ),
    GRID( "grid" ),
    HAIR_CROSS( "hair-cross" ),
    HAND( "hand" ),
    HEART_OUTLINED( "heart-outlined" ),
    HEART( "heart" ),
    HELP_WITH_CIRCLE( "help-with-circle" ),
    HELP( "help" ),
    HOME( "home" ),
    HOUR_GLASS( "hour-glass" ),
    IMAGE_INVERTED( "image-inverted" ),
    IMAGE( "image" ),
    IMAGES( "images" ),
    INBOX( "inbox" ),
    INFINITY( "infinity" ),
    INFO_WITH_CIRCLE( "info-with-circle" ),
    INFO( "info" ),
    KEY( "key" ),
    KEYBOARD( "keyboard" ),
    LAB_FLASK( "lab-flask" ),
    LANDLINE( "landline" ),
    LANGUAGE( "language" ),
    LAPTOP( "laptop" ),
    LEAF( "leaf" ),
    LEVEL_DOWN( "level-down" ),
    LEVEL_UP( "level-up" ),
    LIFEBUOY( "lifebuoy" ),
    LIGHT_BULB( "light-bulb" ),
    LIGHT_DOWN( "light-down" ),
    LIGHT_UP( "light-up" ),
    LINE_GRAPH( "line-graph" ),
    LINK( "link" ),
    LIST( "list" ),
    LOCATION_PIN( "location-pin" ),
    LOCATION( "location" ),
    LOCK_OPEN( "lock-open" ),
    LOCK( "lock" ),
    LOG_OUT( "log-out" ),
    LOGIN( "login" ),
    LOOP( "loop" ),
    MAGNET( "magnet" ),
    MAGNIFYING_GLASS( "magnifying-glass" ),
    MAIL( "mail" ),
    MAN( "man" ),
    MAP( "map" ),
    MASK( "mask" ),
    MEDAL( "medal" ),
    MEGAPHONE( "megaphone" ),
    MENU( "menu" ),
    MESSAGE( "message" ),
    MIC( "mic" ),
    MINUS( "minus" ),
    MOBILE( "mobile" ),
    MODERN_MIC( "modern-mic" ),
    MOON( "moon" ),
    MOUSE( "mouse" ),
    MUSIC( "music" ),
    NETWORK( "network" ),
    NEW_MESSAGE( "new-message" ),
    NEW( "new" ),
    NEWS( "news" ),
    NOTE( "note" ),
    NOTIFICATION( "notification" ),
    OLD_MOBILE( "old-mobile" ),
    OLD_PHONE( "old-phone" ),
    PALETTE( "palette" ),
    PAPER_PLANE( "paper-plane" ),
    PENCIL( "pencil" ),
    PHONE( "phone" ),
    PIE_CHART( "pie-chart" ),
    PIN( "pin" ),
    PLUS( "plus" ),
    POPUP( "popup" ),
    POWER_PLUG( "power-plug" ),
    PRICE_RIBBON( "price-ribbon" ),
    PRICE_TAG( "price-tag" ),
    PRINT( "print" ),
    PROGRESS_EMPTY( "progress-empty" ),
    PROGRESS_FULL( "progress-full" ),
    PROGRESS_ONE( "progress-one" ),
    PROGRESS_TWO( "progress-two" ),
    PUBLISH( "publish" ),
    QUOTE( "quote" ),
    RADIO( "radio" ),
    REPLY_ALL( "reply-all" ),
    REPLY( "reply" ),
    RETWEET( "retweet" ),
    ROCKET( "rocket" ),
    ROUND_BRUSH( "round-brush" ),
    RSS( "rss" ),
    RULER( "ruler" ),
    SCISSORS( "scissors" ),
    SHARE_ALTERNITIVE( "share-alternitive" ),
    SHARE( "share" ),
    SHAREABLE( "shareable" ),
    SHIELD( "shield" ),
    SHOP( "shop" ),
    SHOPPING_BAG( "shopping-bag" ),
    SHOPPING_BASKET( "shopping-basket" ),
    SHOPPING_CART( "shopping-cart" ),
    SHUFFLE( "shuffle" ),
    SIGNAL( "signal" ),
    SOUND_MIX( "sound-mix" ),
    SPORTS_CLUB( "sports-club" ),
    SPREADSHEET( "spreadsheet" ),
    SQUARED_CROSS( "squared-cross" ),
    SQUARED_MINUS( "squared-minus" ),
    SQUARED_PLUS( "squared-plus" ),
    STAR_OUTLINED( "star-outlined" ),
    STAR( "star" ),
    STOPWATCH( "stopwatch" ),
    SUITCASE( "suitcase" ),
    SWAP( "swap" ),
    SWEDEN( "sweden" ),
    SWITCH( "switch" ),
    TABLET( "tablet" ),
    TAG( "tag" ),
    TEXT_DOCUMENT_INVERTED( "text-document-inverted" ),
    TEXT_DOCUMENT( "text-document" ),
    TEXT( "text" ),
    THERMOMETER( "thermometer" ),
    THUMBS_DOWN( "thumbs-down" ),
    THUMBS_UP( "thumbs-up" ),
    THUNDER_CLOUD( "thunder-cloud" ),
    TICKET( "ticket" ),
    TIME_SLOT( "time-slot" ),
    TOOLS( "tools" ),
    TRAFFIC_CONE( "traffic-cone" ),
    TREE( "tree" ),
    TROPHY( "trophy" ),
    TV( "tv" ),
    TYPING( "typing" ),
    UNREAD( "unread" ),
    UNTAG( "untag" ),
    USER( "user" ),
    USERS( "users" ),
    V_CARD( "v-card" ),
    VIDEO( "video" ),
    VINYL( "vinyl" ),
    VOICEMAIL( "voicemail" ),
    WALLET( "wallet" ),
    WATER( "water" ),
    PX_WITH_CIRCLE( "px-with-circle" ),
    PX( "px" ),
    BASECAMP( "basecamp" ),
    BEHANCE( "behance" ),
    CREATIVE_CLOUD( "creative-cloud" ),
    DROPBOX( "dropbox" ),
    EVERNOTE( "evernote" ),
    FLATTR( "flattr" ),
    FOURSQUARE( "foursquare" ),
    GOOGLE_DRIVE( "google-drive" ),
    GOOGLE_HANGOUTS( "google-hangouts" ),
    GROOVESHARK( "grooveshark" ),
    ICLOUD( "icloud" ),
    MIXI( "mixi" ),
    ONEDRIVE( "onedrive" ),
    PAYPAL( "paypal" ),
    PICASA( "picasa" ),
    QQ( "qq" ),
    RDIO_WITH_CIRCLE( "rdio-with-circle" ),
    RENREN( "renren" ),
    SCRIBD( "scribd" ),
    SINA_WEIBO( "sina-weibo" ),
    SKYPE_WITH_CIRCLE( "skype-with-circle" ),
    SKYPE( "skype" ),
    SLIDESHARE( "slideshare" ),
    SMASHING( "smashing" ),
    SOUNDCLOUD( "soundcloud" ),
    SPOTIFY_WITH_CIRCLE( "spotify-with-circle" ),
    SPOTIFY( "spotify" ),
    SWARM( "swarm" ),
    VINE_WITH_CIRCLE( "vine-with-circle" ),
    VINE( "vine" ),
    VK_ALTERNITIVE( "vk-alternitive" ),
    VK_WITH_CIRCLE( "vk-with-circle" ),
    VK( "vk" ),
    XING_WITH_CIRCLE( "xing-with-circle" ),
    XING( "xing" ),
    YELP( "yelp" ),
    DRIBBBLE_WITH_CIRCLE( "dribbble-with-circle" ),
    DRIBBBLE( "dribbble" ),
    FACEBOOK_WITH_CIRCLE( "facebook-with-circle" ),
    FACEBOOK( "facebook" ),
    FLICKR_WITH_CIRCLE( "flickr-with-circle" ),
    FLICKR( "flickr" ),
    GITHUB_WITH_CIRCLE( "github-with-circle" ),
    GITHUB( "github" ),
    GOOGLE_WITH_CIRCLE( "google-with-circle" ),
    GOOGLE( "google" ),
    INSTAGRAM_WITH_CIRCLE( "instagram-with-circle" ),
    INSTAGRAM( "instagram" ),
    LASTFM_WITH_CIRCLE( "lastfm-with-circle" ),
    LASTFM( "lastfm" ),
    LINKEDIN_WITH_CIRCLE( "linkedin-with-circle" ),
    LINKEDIN( "linkedin" ),
    PINTEREST_WITH_CIRCLE( "pinterest-with-circle" ),
    PINTEREST( "pinterest" ),
    RDIO( "rdio" ),
    STUMBLEUPON_WITH_CIRCLE( "stumbleupon-with-circle" ),
    STUMBLEUPON( "stumbleupon" ),
    TUMBLR_WITH_CIRCLE( "tumblr-with-circle" ),
    TUMBLR( "tumblr" ),
    TWITTER_WITH_CIRCLE( "twitter-with-circle" ),
    TWITTER( "twitter" ),
    VIMEO_WITH_CIRCLE( "vimeo-with-circle" ),
    VIMEO( "vimeo" ),
    YOUTUBE_WITH_CIRCLE( "youtube-with-circle" ),
    YOUTUBE( "youtube" );


    private static final String ICON_NAME = "%s:%s";

    private static final String ICON_NAME_SEPARATOR = ":";

    public static final String ICON_COLLECTION_NAME = "entypo";

    public static final String ICON_DESCRIPTION = "Entypo";

    private String name;

    EntypoIcon( String name )
    {
        this.name = name;
    }

    @SuppressWarnings( "deprecation" )
    public Icon create()
    {
        return new Icon( ICON_COLLECTION_NAME, name );
    }

    public String getIconName()
    {
        return String.format( ICON_NAME, ICON_COLLECTION_NAME, name );
    }
    

    public String getIconCollectionName( String iconName )
    {
        return iconName.split( ICON_NAME_SEPARATOR )[0];
    }


}
