/**
 * Copyright (C) 2020-2022 Dušan Vejnović <vaadin@dussan.org>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.dussan.vaadin.dvirtual.icons;

import com.vaadin.flow.component.icon.Icon;

public enum WpzoomIcon
{

    FACEBOOK( "facebook" ),
    TWITTER_OLD( "twitter-old" ),
    SHARE( "share" ),
    FEED( "feed" ),
    BIRD( "bird" ),
    CHAT( "chat" ),
    ENVELOPE( "envelope" ),
    ENVELOPE1( "envelope1" ),
    PHONE( "phone" ),
    PHONE1( "phone1" ),
    PHONE2( "phone2" ),
    MOBILE( "mobile" ),
    IPOD( "ipod" ),
    MONITOR( "monitor" ),
    LAPTOP( "laptop" ),
    MODEM( "modem" ),
    SPEAKER( "speaker" ),
    WINDOW( "window" ),
    SERVER( "server" ),
    HDD( "hdd" ),
    KEYBOARD( "keyboard" ),
    MOUSE( "mouse" ),
    CD( "cd" ),
    FLOPPY( "floppy" ),
    HARDWARE( "hardware" ),
    USB( "usb" ),
    CORD( "cord" ),
    SOCKET( "socket" ),
    SOCKET1( "socket1" ),
    SOCKET2( "socket2" ),
    PRINTER( "printer" ),
    CAMERA( "camera" ),
    PICTURES( "pictures" ),
    EYE( "eye" ),
    UNTITLED( "untitled" ),
    FILM( "film" ),
    CAMERA1( "camera1" ),
    MOVIE( "movie" ),
    TV( "tv" ),
    CAMERA2( "camera2" ),
    CAMERA3( "camera3" ),
    VOLUME( "volume" ),
    MUSIC( "music" ),
    MICROPHONE( "microphone" ),
    RADIO( "radio" ),
    IPOD1( "ipod1" ),
    HEADPHONE( "headphone" ),
    CASSETTE( "cassette" ),
    BROADCAST( "broadcast" ),
    BROADCAST1( "broadcast1" ),
    CALCULATOR( "calculator" ),
    GAMEPAD( "gamepad" ),
    GAMEPAD1( "gamepad1" ),
    COG( "cog" ),
    SHIELD( "shield" ),
    SKULL( "skull" ),
    BUG( "bug" ),
    MINE( "mine" ),
    EARTH( "earth" ),
    GLOBE( "globe" ),
    PLANET( "planet" ),
    BATTERY( "battery" ),
    BATTERY_LOW( "battery-low" ),
    BATTERY1( "battery1" ),
    BATTERY_FULL( "battery-full" ),
    FOLDER( "folder" ),
    SEARCH( "search" ),
    ZOOMOUT( "zoomout" ),
    ZOOMIN( "zoomin" ),
    BINOCULAR( "binocular" ),
    LOCATION( "location" ),
    PIN( "pin" ),
    FILE( "file" ),
    TAG( "tag" ),
    QUOTE( "quote" ),
    ATTACHMENT( "attachment" ),
    BOOKMARK( "bookmark" ),
    BOOKMARK1( "bookmark1" ),
    NEWSPAPER( "newspaper" ),
    NOTEBOOK( "notebook" ),
    ADDRESSBOOK( "addressbook" ),
    CLIPBOARD( "clipboard" ),
    CLIPBOARD1( "clipboard1" ),
    BOARD( "board" ),
    PENCIL( "pencil" ),
    PEN( "pen" ),
    USER( "user" ),
    USER1( "user1" ),
    USER2( "user2" ),
    TRASHCAN( "trashcan" ),
    CART( "cart" ),
    BAG( "bag" ),
    SUITCASE( "suitcase" ),
    CARD( "card" ),
    BOOK( "book" ),
    GIFT( "gift" ),
    LAMP( "lamp" ),
    SETTINGS( "settings" ),
    SUPPORT( "support" ),
    MEDICINE( "medicine" ),
    CONE( "cone" ),
    LOCKED( "locked" ),
    UNLOCKED( "unlocked" ),
    KEY( "key" ),
    INFO( "info" ),
    CLOCK( "clock" ),
    TIMER( "timer" ),
    FOOD( "food" ),
    DRINK( "drink" ),
    MUG( "mug" ),
    CUP( "cup" ),
    DRINK1( "drink1" ),
    MUG1( "mug1" ),
    LOLLIPOP( "lollipop" ),
    LAB( "lab" ),
    PUZZLE( "puzzle" ),
    FLAG( "flag" ),
    STAR( "star" ),
    HEART( "heart" ),
    BADGE( "badge" ),
    CUP1( "cup1" ),
    SCISSORS( "scissors" ),
    SNOWFLAKE( "snowflake" ),
    CLOUD( "cloud" ),
    LIGHTNING( "lightning" ),
    NIGHT( "night" ),
    SUNNY( "sunny" ),
    DROPLET( "droplet" ),
    UMBRELLA( "umbrella" ),
    TRUCK( "truck" ),
    CAR( "car" ),
    GASPUMP( "gaspump" ),
    FACTORY( "factory" ),
    TREE( "tree" ),
    LEAF( "leaf" ),
    FLOWER( "flower" ),
    DIRECTION( "direction" ),
    THUMBSUP( "thumbsup" ),
    THUMBSDOWN( "thumbsdown" ),
    POINTER( "pointer" ),
    POINTER1( "pointer1" ),
    POINTER2( "pointer2" ),
    POINTER3( "pointer3" ),
    ARROW_UP( "arrow-up" ),
    ARROW_DOWN( "arrow-down" ),
    ARROW_LEFT( "arrow-left" ),
    ARROW_RIGHT( "arrow-right" ),
    ARROW_TOP_RIGHT( "arrow-top-right" ),
    ARROW_TOP_LEFT( "arrow-top-left" ),
    ARROW_BOTTOM_RIGHT( "arrow-bottom-right" ),
    ARROW_BOTTOM_LEFT( "arrow-bottom-left" ),
    CONTRACT( "contract" ),
    ENLARGE( "enlarge" ),
    REFRESH( "refresh" );

    private static final String ICON_NAME = "%s:%s";

    private static final String ICON_NAME_SEPARATOR = ":";

    public static final String ICON_COLLECTION_NAME = "wpzoom";

    public static final String ICON_DESCRIPTION = "Wpzoom";

    private String name;

    WpzoomIcon( String name )
    {
        this.name = name;
    }

    @SuppressWarnings( "deprecation" )
    public Icon create()
    {
        return new Icon( ICON_COLLECTION_NAME, name );
    }

    public String getIconName()
    {
        return String.format( ICON_NAME, ICON_COLLECTION_NAME, name );
    }

    public String getIconCollectionName( String iconName )
    {
        return iconName.split( ICON_NAME_SEPARATOR )[0];
    }

}
